unit FormInput;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls;

type
  TfrmSetting = class(TForm)
    PageControl: TPageControl;
    btnOK: TButton;
    btnCancel: TButton;
    tsJoypad1: TTabSheet;
    tsJoypad2: TTabSheet;
    Label1: TLabel;
    cb1UP: TComboBox;
    Label2: TLabel;
    cb1Left: TComboBox;
    Label3: TLabel;
    cb1right: TComboBox;
    Label4: TLabel;
    cb1down: TComboBox;
    Label5: TLabel;
    cb1A: TComboBox;
    Label6: TLabel;
    cb1B: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    cb1Select: TComboBox;
    Label9: TLabel;
    cb1Start: TComboBox;
    tsScreen: TTabSheet;
    cbJoy: TCheckBox;
    RadioButton1: TRadioButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSetting: TfrmSetting;

implementation

uses NesForm, Registry;

{$R *.DFM}

procedure TfrmSetting.FormCreate(Sender: TObject);
var
  Reg : TRegistry;
begin
  cb1UP.Items.AddObject('BACK', TObject(8));
  cb1UP.Items.AddObject('TAB', TObject(9));
  cb1UP.Items.AddObject('CLEAR', TObject(12));
  cb1UP.Items.AddObject('RETURN', TObject(13));
  cb1UP.Items.AddObject('SHIFT', TObject($10));
  cb1UP.Items.AddObject('CONTROL', TObject(17));
  cb1UP.Items.AddObject('ESCAPE', TObject(27));
  cb1UP.Items.AddObject('SPACE', TObject($20));
  cb1UP.Items.AddObject('PAG UP', TObject(33)); //PRIOR
  cb1UP.Items.AddObject('PAG DOWN', TObject(34)); //NEXT
  cb1UP.Items.AddObject('END', TObject(35));
  cb1UP.Items.AddObject('HOME', TObject(36));
  cb1UP.Items.AddObject('LEFT', TObject(37));
  cb1UP.Items.AddObject('UP', TObject(38));
  cb1UP.Items.AddObject('RIGHT', TObject(39));
  cb1UP.Items.AddObject('DOWN', TObject(40));
  cb1Down.Items.Assign(cb1UP.Items);
  cb1Left.Items.Assign(cb1UP.Items);
  cb1Right.Items.Assign(cb1UP.Items);
  cb1A.Items.Assign(cb1UP.Items);
  cb1B.Items.Assign(cb1UP.Items);
  cb1Start.Items.Assign(cb1UP.Items);
  cb1Select.Items.Assign(cb1UP.Items);
  { load default values }
  Reg := TRegistry.Create;
  if Reg.OpenKey('Software\Karakiri\WinNES', true) then
  begin
    if Reg.ValueExists('BUTTON1 UP') then
      cb1Up.ItemIndex := Reg.ReadInteger('BUTTON1 UP')
    else
      cb1Up.ItemIndex := 13;
    if Reg.ValueExists('BUTTON1 DOWN') then
      cb1Down.ItemIndex := Reg.ReadInteger('BUTTON1 DOWN')
    else
      cb1Down.ItemIndex := 15;
    if Reg.ValueExists('BUTTON1 LEFT') then
      cb1Left.ItemIndex := Reg.ReadInteger('BUTTON1 LEFT')
    else
      cb1Left.ItemIndex := 12;
    if Reg.ValueExists('BUTTON1 RIGHT') then
      cb1Right.ItemIndex := Reg.ReadInteger('BUTTON1 RIGHT')
    else
      cb1Right.ItemIndex := 14;
    if Reg.ValueExists('BUTTON1 A') then
      cb1A.ItemIndex := Reg.ReadInteger('BUTTON1 A')
    else
      cb1A.ItemIndex := 4;
    if Reg.ValueExists('BUTTON1 B') then
      cb1B.ItemIndex := Reg.ReadInteger('BUTTON1 B')
    else
      cb1B.ItemIndex := 5;
    if Reg.ValueExists('BUTTON1 START') then
      cb1Start.ItemIndex := Reg.ReadInteger('BUTTON1 START')
    else
      cb1Start.ItemIndex := 3;
    if Reg.ValueExists('BUTTON1 SELECT') then
      cb1Select.ItemIndex := Reg.ReadInteger('BUTTON1 SELECT')
    else
      cb1Select.ItemIndex := 7;
  end;
  Reg.free;
end;

end.
